﻿function getCategorias() {
  params = {
      service: 'getCategorias',
      dbName: dbName,
      idEmpresas: localStorage.idEmpresas
  };
  $.post(host, params, function(data) {
      $("#categorias").html('');
      var component = "";
      $.each(data, function(key, val) {
          component += `<li class='tab'>`;
          component += `<a onclick='getProductosCategorias(${val.id});'>${val.descripcion}</a></li>`;
      });
      $("#categorias").html(component);
      $('.tabs').tabs();
  }, 'json');
}

function getProductosCategorias(idCategorias) {
  params = {
      service: 'getProductosCategorias',
      idCategorias: idCategorias,
      dbName: dbName,
      idEmpresas: localStorage.idEmpresas
  };
  $.post(host, params, function(data) {
      $("#productos").html('');
      var component = ``;

      $.each(data, function(key, val) {
          var image = hostImages + val.image;

          let color = (accounting.unformat(val.existencia) > 0) ? 'light-green' : 'deep-orange ';
          let icon = (accounting.unformat(val.existencia) > 0) ? 'check' : 'clear';
          let showIcon = (val.idTipoProductos == 3) ? false : true;

          component += `<div class="col m3 s6">
                          <div class="card shapedbox" onclick="agregarProductoVenta(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}');" >
                              <div class="card-image" >
                                  <img src="${image}" class='responsive-img imgProducto center'>
                              </div>
                              <div class="card-content">
                                  <p class='nombre-card truncate'>
                                    ${val.descLarga.toLowerCase()}
                                  </p>
                                  <p class='truncate sku-card'>
                                      ${val.sku}
                                  </p>`;

          if (showIcon) {
            component += `<a class="btn-existencias btn-floating btn-flat btn-small waves-effect waves-light ${color}"><i class="material-icons">${icon}</i></a>`
          }
          
          component += `<p class='precio-card'>
                                    Q${val.precioPublico}
                                  </p>
                              </div>
                          </div>
                      </div>`;
      });
      $("#productos").html(component);

      $('img').each(function() {
        if ( !this.complete
        ||   typeof this.naturalWidth == "undefined"
        ||   this.naturalWidth == 0) {
          // image was broken, replace with your new image
          this.style = 'display:none';
          this.src = 'assets/images/default.jpg';
        }
      });

  }, 'json');

}

function agregarProductoVenta(idProductos, existencia, idTipoProductos, producto) {
  params = {
    service: 'agregarProductoVenta',
    idProductos: idProductos,
    dbName: dbName,
    idEmpresas: localStorage.idEmpresas,
    idSucursales: localStorage.idSucursales,
    idUsuarios: localStorage.idUsuarios,
    cantidad: 1
  };

  $("#loader").show();
  if (idTipoProductos === 1) {
    if (accounting.unformat(existencia) > 0) {
      
      $.post(host, params, function(data) {
        $.each(data, function(key, val) {
          switch (val.message) {
              case 'success':
                  loadProductosVenta();
                  break;
              case 'sin_existencia':
                  errorMsg = `No hay existencias de componentes del producto: ${producto} \n`;
                  errorMsg += 'Producto: ' + val.producto + '\n';
                  errorMsg += 'Exitencia: ' + val.existencia + '\n';
                  errorMsg += 'Cantidad solicitada: ' + val.cantidad + '\n';
                  
                  Swal.fire({
                      title: `${producto}`,
                      text: `No hay existencias de los componentes`,
                      icon: 'warning',
                      confirmButtonColor: '#3085d6',
                      confirmButtonText: 'Ok'
                  }).then((result) => {
                      
                  });

                  break;
              default:
                  alert(`Error ${val.error}`);
                  break;
          }
        });
      }, 'json').done(function() {
          $("#loader").hide();
      });
    }
  }
  else{
    $.post(host, params, function(data) {
      $.each(data, function(key, val) {
          switch (val.message) {
              case 'success':
                  loadProductosVenta();
                  break;
              case 'sin_existencia':
                  errorMsg = `No hay existencias de componentes del producto: ${producto} \n`;
                  errorMsg += 'Producto: ' + val.producto + '\n';
                  errorMsg += 'Exitencia: ' + val.existencia + '\n';
                  errorMsg += 'Cantidad solicitada: ' + val.cantidad + '\n';
                  
                  Swal.fire({
                    title: `${producto}`,
                    text: `No hay existencias de los componentes`,
                    icon: 'warning',
                    confirmButtonColor: '#3085d6',
                    confirmButtonText: 'Ok'
                  }).then((result) => {
                      
                  });

                  break;
              default:
                  alert(`Error ${val.error}`);
                  break;
          }
      });
    }, 'json').done(function() {
        $("#loader").hide();
    });
  }
  
}

function loadProductosVenta() {
  $("#detalleCarrito,#resumenCarrito").html('');
  params = {
      service: 'loadProductosVenta',
      dbName: dbName,
      idUsuarios: localStorage.idUsuarios
  };
  $.post(host, params, function(data) {
      var detail = "";
      var summary = "";
      var total1 = 0;
      var total2 = 0;
      if (data === null) {
          detail += '<li>';
          detail += '<div class="row detalleCarrito">';
          detail += '<div class="col s12 center-align">';
          detail += '0 registros encontrados en el carrito';
          detail += '</div>';
          detail += '</div>';
          detail += '</li>';
      } else {
          detail = "";
          $.each(data, function(key, val) {
              var Upc = "'" + val.Upc + "'";
              var Precio = "'" + accounting.unformat(val.precio) + "'";
              total1 += accounting.unformat(val.total);
              total2 += accounting.unformat(val.cantidad);
              detail += `<li class="collection-item" onclick="eliminarProductoVenta(${val.id},'${val.descLarga}');">`;
              detail += '<div class="row detalleCarrito">';
              detail += '<div class="col s2 left-align">';
              detail += '<span>' + accounting.formatNumber(val.cantidad, 0) + 'x</span>';
              //detail += '<i class="mdi mdi-minus-circle red-text" onclick="quitarItemCarrito(' + Upc + ',' + accounting.formatNumber(val.cantidad, 0) + ',' + val.id + ');"></i>';
              detail += '</div>';
              detail += '<div class="col s6 left-align truncate">' + val.descLarga.toLowerCase() + '</div>';
              detail += '<div class="col s4 right-align">';
              detail += 'Q ' + accounting.formatNumber(val.total, 2);
              //detail += '<i class="mdi mdi-plus-circle red-text" onclick="agregarItemCarrito(' + Upc + ', ' + Precio + ');"></i>';
              detail += '</div>';
              detail += '</div>';
              detail += '</li>';
          });
          // summary += '<li class="collection-item">';
          // summary += 'No. Productos:';
          // summary += `<span class="totales"><input type="hidden" id="totalItems" value="${total2}"/>${accounting.formatNumber(total2, 0)}</span>`;
          // summary += '</li>';
          // summary += '<li class="collection-item">';
          // summary += `<div class="row" style='margin-bottom:0px !important;'>`;
          // summary += `<div class="col s2 left-align" style='font-size:1.5em !important;'>Total:</div>`;
          // summary += `<div class="col s10 right-align"><span class="totales" style='font-size:1.5em !important;'><input type="hidden" id="total" value="${total1}"/>Q. ${accounting.formatNumber(total1, 2)}</span></div>`;
          // summary += `</div>`;
          // summary += '</li>';
          $('#total').val(total1);
          $('#totalItems').val(total2);
          $('#spanTotal').html("Q " + accounting.formatNumber(total1, 2));
      }
      $("#detalleCarrito").append(detail);
      $("#resumenCarrito").append(summary);
  }, 'json').done(function() {
      $("#loader").hide();
  });
}

function eliminarProductoVenta(id, descLarga) {
    
  Swal.fire({
      title: '&iquest;Eliminar Producto?',
      text: `${descLarga}`,
      icon: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Si',
      cancelButtonText: 'Cancelar'
  }).then((result) => {
      if (result.value) {
          params = {
              service: 'eliminarProductoVenta',
              dbName: dbName,
              id: id
          };
          $.post(host, params, function(data) {
              $.each(data, function(key, val) {
                  if (val.message === 'success') {
                      loadProductosVenta();
                  } else {
                      alert(`Error: ${val.Query}`);
                  }
              });
          }, 'json');
      }
  });
}

function valeCaja() {
  $(".modal-content .row").html('');
  $("#modal-title").html('VALE DE CAJA');
  $('#modal1').openModal();
  component = `<div class='col s6'>
              <label>SOLICITADO POR</label>
              </div>
              <div class='col s6'>
              <input type='text' id="solicitado" class='inputs'/>
              </div>
              <div class='col s6'>
              <label>MONTO</label>
              </div>
              <div class='col s6'>
              <input type='number' id="monto" class='inputs'/>
              </div>
              <div class='col s6'>
              <label>MOTIVO</label>
              </div>
              <div class='col s6'>
              <input type='text' id="motivoVale" class='inputs'/>
              </div>
              <div class='col s12 center-align'>
              <br/>
              <button class="waves-effect waves-light btn green middle-align" onclick="registrarVale();">REGISTRAR VALE&nbsp;<i class="mdi mdi-check-circle"></i></button>
              </div>`;
  $(".modal-content .row").html(component);
}

function registrarVale() {
  var solicitadoPor = $("#solicitado").val();
  var monto = $("#monto").val();
  var observaciones = $("#motivoVale").val();
  var errorMsg = "Corrige los siguiente errores:\n";
  var flag = true;
  if (!solicitadoPor) {
      flag = false;
      errorMsg += 'Ingrese nombre del solicitante\n';
  }
  if (!monto) {
      flag = false;
      errorMsg += 'Ingrese monto del vale\n';
  }
  if (!$.isNumeric(monto)) {
      flag = false;
      errorMsg += 'Valor en monto incorrecto\n';
  }
  if (!observaciones) {
      flag = false;
      errorMsg += 'Ingrese motivo del vale\n';
  }
  if (flag === false) {
      alert(errorMsg);
      return false;
  } else {
      params = {
          service: 'registrarVale',
          solicitadoPor: solicitadoPor,
          monto: monto,
          observaciones: observaciones,
          dbName: dbName,
          idSucursales: localStorage.idSucursales,
          idUsuarios: localStorage.idUsuarios,
          idEmpresas: localStorage.idEmpresas
      };
      $.post(host, params, function(respuesta) {
          $.each(respuesta, function(key, val) {
              if (val.message === 'success') {
                  alert('Vale operado exitosamente');
                  cerrarModal();
              } else {
                  alert('Error al ingresar vale');
              }
          });
      }, 'json');
  }
}

function cerrarModal() {
  $("#modal1").closeModal();
}

function onBackKeyDown() {
    logout();
}

function logout(){
    Swal.fire({
        title: '&iquest;Desea Continuar?',
        icon: 'question',
        showCancelButton: false,
        showCloseButton: true,
        confirmButtonColor: '#3085d6',
        confirmButtonText: 'Cerrar Sesi&oacute;n',
      }).then((result) => {
        if (result.value) {
            localStorage.idUsuarios = undefined;
            localStorage.nombreUsuario = undefined;
            localStorage.tipoUsuario = undefined;
            localStorage.idSucursales = undefined;
            localStorage.idEmpresas = undefined;
            window.location = "index.html";
        }
      });
}



  $(document).ready(function(){
    createSideMenu();
    $('.sidenav').sidenav();
    $('.modal').modal();
    
    //getScreenDim();
  });

  function openSideMenu(){
    $('.sidenav').sidenav('open');
  }

  function cerrarCaja() {
      localStorage.idUsuarios = undefined;
      localStorage.nombreUsuario = undefined;
      localStorage.tipoUsuario = undefined;
      localStorage.idSucursales = undefined;
      localStorage.idEmpresas = undefined;
      window.location = "index.html";
  }