$(document).ready(function () {
	aperturaCaja();
	getDocumentoFacturacion();
	getDocumentoRecibo();

	if(!emitirRecibo)
		$('#divTipTrans').hide();

	//inicializar con tipo de moneda Quetzal
	$("#tipoMoneda").val("1");
	$("#tipoMoneda").change(function () {
		if ($(this).is(":checked")) {
			$("#tipoMoneda").val("2");
			returnProductos();
		} else {
			$("#tipoMoneda").val("1");
			returnProductos();
		}
	});

});

// Barra Search (version mobile)
$("#buscador").on("keyup", function() {
     var value = $(this).val().toLowerCase();
    $("#productosMobile div.mdl-cell").filter(function() {
      $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
    });
});

// ? Paso 1: Seleccionar el cliente al que se le va a aplicar el cobro.
function showDetalles(){
	$('#btnBackTool').hide();
	$('#divTipMoneda').hide();
	$('#divTipTrans').hide();
	$('#btnTotal').hide();
	$('#productosMobile').empty();
	$('#textBuscador').show();
	$('input[type=text], textarea').val('');
	drawDetalles();
	$('#btnDespachar').hide();
}

//? Paso 1 draw se dibuja la pantalla para visualizar los clientes asignados al cobrador.
function drawDetalles() {
	params = {
		service: "clientesCobrador",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales,
	};
	$.post(host, params, function (data) {
		$("#productosMobile").empty();
		var component = `<div class="header-servicios">Cobrador: ${localStorage.nombreUsuario.toLowerCase()} </div>`;
		$.each(data, function (key, val) {

			component += `
			<div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-phone">
				<div class="mdl-card mdl-shadow--2dp card shapedbox" onclick="resetCarrito(${val.idCliente},'${val.nombreCliente}','${val.sector}','${val.direccionC}','${val.nitC}','${val.codigoC}')" >
					<p class="nombre-card-Mobile">${val.nombreCliente.toLowerCase()}</p></br>
					<div class="mdl-card__supporting-text">
						</br> 
						<p class="" style="font-size: large; margin-bottom: 0px !important; text-transform: capitalize;">
							${val.direccionC.toLowerCase()}</br>
							${val.sector.toLowerCase()}</br>
							<b>${val.servicios.toLowerCase()}</b></br>
							Total Deuda: <b> Q${val.saldoGlobal}</b>
						</p>				
					</div>
				</div>
			</div>`;
		});
			$("#productosMobile").append(component);
		},
		"json",
	);
}

// * Función para evitar que se mezclen servicios de varios clientes en el carrito.
function resetCarrito(idCliente,nombreC,sector,direccionC,nitC,codigoC){
	//* Se declaran los datos del cliente para pintarlos en distintas pantallas.
	$("#nombreC").val(nombreC);
	$("#sector").val(sector);
	$("#direccionC").val(direccionC);
	$("#nitC").val(nitC);
	$("#idCliente").val(idCliente);
	$("#codClienteM").val(codigoC);

	params = {
		service: "eliminarCarrito",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idUsuarios: localStorage.idUsuarios
	};
	$.post(host,params,function (data) {
		$.each(data, function (key, val) {
			if (val.message === "success") {
				showServicios();
			} else {
				alert(`Error: ${val.Query}`);
			}
		});
	},"json",
	).done(function () {
	});
}

function showServicios(){

	$('#btnBackTool').show();
	$('#btnBackTool').attr('onclick', 'showDetalles()');

	$('#divTipMoneda').hide();
	$('#textBuscador').hide();
	$('#divTipTrans').hide();

	$('#productosMobile').height(canvasH);
	$('#productosMobile').empty();

	drawServicios();
	
	$('#btnDespachar').show();
	$('#btnDetalles').hide();
	$('#btnTotal').hide();
}

function drawServicios() {

	let nombreC = $("#nombreC").val();
	let sector = $("#sector").val();
	let idCliente = $("#idCliente").val();
	let direccion = $("#direccionC").val();
	let codCliente = $("#codClienteM").val();

	params = {
		service: "serviciosGeneral",
		dbName: dbName,
		idCliente: idCliente,
	};
	$.post(host, params, function (data) {
		$("#productosMobile").empty();
		
		var component = `
		<div style="text-transform: capitalize;margin-left: 5px;font-size: large;">
			<b>C&oacute;digo Cliente: </b>${codCliente}
			</br>
			<b>Nombre: </b>${nombreC.toLowerCase()}
			</br>
			<b>Sector: </b> ${sector.toLowerCase()}
			</br>
			<b>Direcci&oacute;n: </b> ${direccion.toLowerCase()}
		</div>
		<div style="text-align:center;font-size: large;margin-top: 10px;"><b>Servicios </b></br></div>`;

		if (data === null) {
			component += `<div style="text-align:center;margin-top: 30px;">El cliente seleccionado no cuenta con servicios asignados</div>`;
		} else {
			$.each(data, function (key, val) {
				component += `
				<div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-phone">
					<div class="mdl-card mdl-shadow--2dp card shapedbox" >
						<div class="mdl-card__supporting-text">
							</br> 
							<p onclick="modalAgregarProducto(${val.idServicio},'${val.descripcion}',${val.saldo},${val.precioCosto},2,'N/A')"  style="font-size: large; margin-bottom: 0px !important; text-transform: capitalize;">
								${val.descripcion.toLowerCase()}</br>
								Saldo: <b> Q${val.saldo}</b></br>
								${val.estado}
							</p>				
						</div>
						<i class="material-icons" onclick="saldosCliente(${val.idServicio},${val.idCliente},'${val.descripcion}')" style="text-align: end;color: darkgray;padding-right: 10px;padding-bottom: 10px;display:none">
							info
						</i>
					</div>

					<div class="mdl-card mdl-shadow--2dp card shapedbox" id="mesPendiente${val.idServicio}" style="margin-top: 5px;display:none"></div>

				</div>`;
			});
		}

		component += `
		<div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-phone" style="margin-bottom: 80px !important;">
			<div class="mdl-card mdl-shadow--2dp card shapedbox" onclick="swalCargoAdicional()" >
				<div class="mdl-card__supporting-text">
					</br> 
					<p class="" style="font-size: large; margin-bottom: 0px !important; text-transform: capitalize;text-align:center;">
						Cargos Adicionales
					</p>				
				</div>
			</div>
		</div>`;

			$("#productosMobile").append(component);
		},
		"json",
	);
}

//* Funcion para traer los datos de los meses del servicio individual
function saldosCliente(id,idCliente,descLarga){
	var component = "";
	params = {
		service: "saldosCliente",
		dbName: dbName,
		idServicio: id,
		idCliente: idCliente,
	};
	$.post(host, params, function (data) {
		$(`#mesPendiente${id}`).empty();
		if (data === null) {
			component += `<div style="text-align:center;margin-top: 10px;">El cliente seleccionado no cuenta con historial de servicios</div>`;
		} else {
			component += `
				<div class="mdl-card__supporting-text">
				</br> 
				<div style="text-align: center;font-size: larger;text-transform:capitalize;	"><b>Servicio: </b> ${descLarga.toLowerCase()}</div>
				<div class="mdl-grid">
				<div class="mdl-cell mdl-cell--2-col" style="text-align:left;font-size: large;margin-top: 10px;"><b>Mes</b></div>
				<div class="mdl-cell mdl-cell--2-col" style="text-align:right;font-size: large;"><b>Estado</b></div>`;
			$.each(data, function (key, val) {
				component += `
				<div class="mdl-cell mdl-cell--2-col" style="text-align:left;font-size: large;margin-top: 10px;">${val.mesDescripcion}</br> Q${val.saldo}</div>
				<div class="mdl-cell mdl-cell--2-col" style="text-align:right;font-size: large;">${val.saldoEstado}</br></div>`;
			});
			component += `</div></div>`;
		}
		$(`#mesPendiente${id}`).append(component);
	}, "json").done(function(){
		$(`#mesPendiente${id}`).slideToggle();
	});
}

function swalCargoAdicional(){
	Swal.fire({ 
		html: `<div style="text-align: center;font-size: larger;"><b>Seleccione un cargo adicional:</b></div></br>
		<select class="browser-default" id="selectCargo" 
		style="border-top-width: 10px;font-size: medium;border: 1px solid white;border-bottom-color: #545454;width: 100%;">		
		</select>`,
		showConfirmButton: true,
		confirmButtonColor: '#ff8f00',
		confirmButtonText: "Agregar",
		onOpen() {
			getCargoAdicional();
		},
		customClass: {
			container: 'my-swal'
		}	
	}).then((result) => {
		if (result.isConfirmed) {
			console.log($("#selectCargo").val());
			let id = $("#selectCargo").val();
			getDatosCargo(id);
		}
	});
}

function getCargoAdicional(){
	//console.log("meep");
	params = {
		service: "getProductos",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales,
	};
	$.post(host, params, function (data) {
		let cargo = `<option value="">Seleccione un cargo...</option>`;
		$.each(data, function (key, val) {
			cargo += `<option value="${val.id}"> ${val.descLarga}</option>`;
		});
		$("#selectCargo").html(cargo);
	}, "json").done(function(){
	});
	
}

function getDatosCargo(id){
	params = {
		service: "getDatosCargo",
		dbName: dbName,
		id: id,
		idSucursales: localStorage.idSucursales,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		$.each(data, function (key, val) {
			modalAgregarProducto(val.id,val.descLarga,val.precioPublico,val.precioCosto,val.idTipoProductos,val.sku);
		});
	}, "json").done(function(){
	});
	
}

function modalAgregarProducto(idServicio,descLarga,precioPublico,precioCosto,tipoProducto,sku){

	//* datos del producto rescatado, no del servicio 
	$("#idServicio").val(idServicio);

	$("#sku").val(sku);

	$("#descripcion").val(descLarga);
	$("#tipoProducto").val(tipoProducto);
	console.log($("#tipoProducto").val());
	$("#precioCosto").val(precioCosto);


	$("#loader").hide();
	$('#btnDespachar').hide();

	$('#btnBackTool').attr('onclick', `showServicios()`);
	$('#btnBackTool').show();
	$('#divTipMoneda').hide();
	$('#productosMobile').empty();
	$('#productosMobile').height('100%');
	//var cantidad =  $("#contador").get(0).value;
	
	//Se guardan valores en ambas monedas
	$("#precioPublico").val(accounting.formatNumber(precioPublico, 2));

	let agregarBody = `
		<div style="text-align: center !important;font-size: large;"><b>Servicio: </b>${descLarga}</div></br>
		<div class="mdl-grid" style="font-size:20px">
			<div class="mdl-cell mdl-cell--2-col-phone">
				Precio: 
			</div>
			<div class="mdl-cell mdl-cell--2-col-phone">
				<input type="text" id="inputPrecio" value="" disabled="" class="big-numbers" style="width: 100%;">
			</div>
		</div>

		<!-- 
		<div class="mdl-grid" style="font-size:20px">
			<div class="mdl-cell mdl-cell--2-col-phone">
				Cantidad: 
			</div>	
			<div class="mdl-cell mdl-cell--2-col-phone">
				<i class="medium material-icons" onclick="cantidad('remove')" 
				style="font-size: 40px;">indeterminate_check_box</i>
				<input class="big-numbers" type="text" id="contador" value="1" min="1" disabled="" style="text-align: center;width: 28%;">
				<i class="medium material-icons" onclick="cantidad('add')" 
				style="font-size: 40px;">add_box</i>
			</div>
		</div>
		
		<div class="mdl-grid" style="font-size:20px">
			<div class="mdl-cell mdl-cell--2-col-phone">
				Total: 
			</div>
			<div class="mdl-cell mdl-cell--2-col-phone">
				<input type="text" id="mTotal" disabled="" class="big-numbers" style="width: 100%;">
			</div>
		</div>-->
		<div class="mdl-grid" style="text-align: center;margin-top: 30px;" id="divNumPadCantidad"></div>`;

	$('#productosMobile').append(agregarBody);
	createNumPad("divNumPadCantidad", "inputPrecio", ".", "", "confirm");
	$("#contador").val("1");

	let moneda = "Q";
	let precio = precioPublico;
	$("#inputPrecio").val(accounting.formatMoney(precio, moneda, 2));
	$("#mTotal").val(accounting.formatMoney(precio, moneda, 2));

	$("#inputPrecio").change(function() {
		let total = accounting.unformat($("#inputPrecio").val());
		let contador = $("#contador").val();
		total = total * contador;		
		let moneda = "Q";
		$("#mTotal").val(accounting.formatMoney(total, moneda, 2));
		
	});
}

function cantidad(boton){
    let precio = accounting.unformat($("#inputPrecio").val());
	let contador = $("#contador").get(0).value;
    let int = parseInt(contador, 10);


    if (boton == 'add'){
        $("#contador").get(0).value = int +1;
    } else {
        $("#contador").get(0).value = int -1;
        if ($("#contador").get(0).value < 1){
            $("#contador").get(0).value = 1;
        }
	}
	let moneda = ($("#tipoMoneda").val() == "2")? "$":"Q";
	let total = $("#contador").get(0).value * precio;
	$("#mTotal").val(accounting.formatMoney(total, moneda, 2));
}

//* Se muestra el carrito por cliente con los servicios x cobrar
function showCarrito(){
	$('#btnBackTool').show();
	$('#btnBackTool').attr('onclick', 'showServicios()');

	$('#btnBackTool2').hide();

	$('#divTipMoneda').hide();
	$('#textBuscador').hide();
	$('#divTipTrans').hide();

	$('#productosMobile').height(canvasH);
	$('#productosMobile').empty();
	loadProductosVenta();
	
	$('#btnDespachar').hide();
	$('#btnDetalles').hide();
	$('#btnTotal').show();

}

/*
//* draw se pinta el carrito
function loadServiciosVenta() {
	params = {
		service: "loadProductosVenta",
		dbName: dbName,
		idUsuarios: localStorage.idUsuarios,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
			drawCart(data);	
		},
		"json",
	).done(function () {
		$("#loader").hide();
	});
}*/

function drawCart(items){
	var detail = "";
	var summary = "";
	var subtotalVenta = 0; //Valor total de la venta sin descuentos
	var total1 = 0;
	var total2 = 0;
	var totalDolar = 0;
	var subtotalDolar = 0;
	var totalDescontado = 0; //Valor total de los descuentos aplicados

	let nombreC = $("#nombreC").val();
	let sector = $("#sector").val();
	let direccion = $("#direccionC").val();
	let codCliente = $("#codClienteM").val();

	if (items === null) {
		detail += `
		<ul id="detalleCarrito" class='mdl-list' >
			<li class="mdl-list__item">
				<span class="mdl-list__item-primary-content">
					<i class="material-icons mdl-list__item-icon">shopping_bag</i>
					No hay servicios seleccionados
				</span>
			</li>
		</ul>`;

		$("#subtotalVenta").val(0);  
		$("#total").val(0);
		$("#totalDescontado").val(0);
		$("#totalItems").val(0);
		//$("#spanTotal").html("Q " + accounting.formatNumber(0, 2));
		if ($("#tipoMoneda").val() == "2"){ //Si es Dolar:
			$("#spanTotal").html("$ " + accounting.formatNumber(0, 2));
		} else {
			$("#spanTotal").html("Q " + accounting.formatNumber(0, 2));				
		}
	} else {
		detail = `
			<div style="text-transform: capitalize;margin-left: 5px;font-size: large;">
				<b>C&oacute;digo Cliente: </b>${codCliente}
				</br>
				<b>Nombre: </b>${nombreC.toLowerCase()}
				</br>
				<b>Sector: </b> ${sector.toLowerCase()}
				</br>
				<b>Direcci&oacute;n: </b> ${direccion.toLowerCase()}
			</div>
			<div style="text-align:center;font-size: large;margin-top: 10px;"><b>Servicios a cobrar </b></br></div>
		<ul id="detalleCarrito" class='mdl-list' style="padding: 0; margin: 0;">`;
		$.each(items, function (key, val) {

			var Upc = "'" + val.Upc + "'";
			//var Precio = "'" + accounting.unformat(val.precio) + "'";
			
			subtotalVenta += accounting.unformat(val.precioServicio);
			total1 += accounting.unformat(val.precioServicio);
		
			total2 += accounting.unformat(val.cantidad);

			// subtotalDolar += accounting.unformat(val.totalDolares + val.descuento); //Cumple la funcion del subtotal sin descuentos
			// totalDolar += accounting.unformat(val.totalDolares);

			totalDescontado += accounting.unformat(val.descuento);

			let precio = "";
			if ($("#tipoMoneda").val() == "2"){ //Si es Dolar
				precio = accounting.formatMoney((val.precioServicio), "$ ", 2); 
			} else {
				//precio = accounting.formatMoney((val.subtotal - val.descuento), "Q ", 2);	
				precio = accounting.formatMoney((val.precioServicio), "Q ", 2);			
			}
			

			if(val.idServicio == null){
				detail += `
				<li class="mdl-list__item mdl-menu__item--full-bleed-divider">
					<span class="mdl-list__item-primary-content" onclick="eliminarProductoVenta(null,'${val.descLarga}',${val.idProductos});">
					<span class="truncate">${val.descLarga.toLowerCase()}</span>
					</span>
					<span class="mdl-list__item-secondary-action" >
						${precio}
					</span>
				</li>
				</ul>`;
			}else{
				detail += `
				<li class="mdl-list__item mdl-menu__item--full-bleed-divider">
					<span class="mdl-list__item-primary-content" onclick="eliminarProductoVenta(${val.idServicio},'${val.descLarga}',${val.idProductos});">
					<span class="truncate">${val.descLarga.toLowerCase()}</span>
					</span>
					<span class="mdl-list__item-secondary-action" >
						${precio}
					</span>
				</li>
				</ul>`;
			}

		});

		if ($("#tipoMoneda").val() == "2"){
			//$("#total").val(totalDolar); // aqui se transforma ya el total a la moneda que deberia guardar 
			
			// $("#totalDolares").val(accounting.formatNumber(totalDolar, 2));
			// $("#subtotalVenta").val(accounting.formatNumber(subtotalDolar, 2));
		}else{
			$("#total").val(accounting.formatNumber(total1, 2));
			$("#subtotalVenta").val(accounting.formatNumber(subtotalVenta, 2)); //Valor total de la venta sin descuentos
		}
		
		$("#totalDescontado").val(accounting.formatNumber(totalDescontado, 2)); //Valor total de los descuentos aplicados
		$("#totalItems").val(total2);

		if ($("#tipoMoneda").val() == "2"){ //Si es Dolar
			// $("#spanTotal").html("$ " + accounting.formatNumber((totalDolar), 2));
		} else {
			$("#spanTotal").html("Q " + accounting.formatNumber(total1, 2));				
		}
	}
	$('#productosMobile').empty();
	$("#productosMobile").append(detail);
	$("#resumenCarrito").append(summary);
}

function showCobro(){
	

	$('#btnBackTool').attr('onclick', `showCarrito()`);
	$('#productosMobile').height('100%');
	$('#btnBackTool').hide();
	$('#btnBackTool2').show();
	drawFormasPago();
	$('#carritoMobile').hide();
	$('#btnDetalles').hide();
	$('#divTipTrans').hide();
	$('#btnTotal').hide();
	$('#btnFinVenta').hide();
}

function drawFormasPago(){
	$('#detalles').hide();

	

	if($( "#divFormasPago" ).length){
		
		$('#divFormasPago').slideDown();
		$('#facturaDatos').remove();
		$('#divNumPadNIT').remove();
	}
	else{
		$('#productosMobile').empty();

		let contenido = `
		<div id="divFormasPago" style="margin-bottom: 0px !important;">
			<div class="mdl-grid no-padding">
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type="text" id="TxtSaldo" class="mdl-textfield__input big-numbers full-width" disabled="">
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect full-width shapedbox" 
						onclick="resetCuenta();">
						<i class="material-icons right">refresh</i>Saldo
					</button>
				</div>
			</div>
	
			<div class="mdl-grid no-padding" id="divEfectivo">
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type='text' id='TxtEfectivo' class="mdl-textfield__input big-numbers full-width formasPago" data-type="1" data-emisor="0" disabled />
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect full-width shapedbox" 
						onclick="calcTotal('TxtEfectivo');">
						<i class="material-icons right">payments</i>Efectivo
					</button>
				</div>
			</div>
	
			<div class="mdl-grid no-padding" id="divDolares" style="display:none;">
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type='text' id='TxtDolares' class="mdl-textfield__input big-numbers full-width formasPago" data-type="2" data-emisor="0" disabled />
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect full-width shapedbox" 
						onclick="calcTotal('TxtDolares');">
						<i class="material-icons right">monetization_on</i>Dolares
					</button>
				</div>
			</div>
	
			<div class="mdl-grid no-padding" id="divVisa" >
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type='text' id='TxtVisa' class="mdl-textfield__input big-numbers full-width formasPago" data-type="5" data-emisor="1" disabled />
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect full-width shapedbox" 
						onclick="calcTotal('TxtVisa');">
						<i class="material-icons right">credit_card</i>VISA
					</button>
				</div>
			</div>

			<div class="mdl-grid no-padding" id="divCheques" >
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type='text' id='TxtCheques' class="mdl-textfield__input big-numbers full-width formasPago" data-type="3" data-emisor="0" disabled />
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect full-width shapedbox" 
						onclick="calcTotal('TxtCheques');">
						<i class="material-icons right">account_balance_wallet</i>Cheques
					</button>
				</div>
			</div>
	
			<div class="mdl-grid no-padding" id="divBac" style="display:none;">
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type='text' id='TxtBac' class="mdl-textfield__input big-numbers full-width formasPago" data-type="5" data-emisor="2" disabled />
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect full-width shapedbox" 
						onclick="calcTotal('TxtBac');">
						<i class="material-icons right">credit_card</i>BAC
					</button>
				</div>
			</div>
	
			<div class="mdl-grid no-padding">
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<input type='text' id='TxtTotal' class="mdl-textfield__input big-numbers full-width" disabled />
				</div>
				<div class="mdl-cell mdl-cell--2-col-phone fp-margin ">
					<button id="btnCobrar" class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect mdl-button--accent full-width shapedbox" 
						onclick="verificarCheque();" disabled="">Confirmar
					</button>
				</div>
			</div>
	
			<div class="mdl-grid no-padding">
				<div class="mdl-cell mdl-cell--4-col-phone fp-margin ">
					<input type="text" id="TxtNumPad" class="mdl-textfield__input big-numbers full-width right-align" disabled="">
				</div>
			</div>
			<div id="divNumPadCobro" class="mdl-grid" style="text-align: center; padding: 0px;"></div>
		</div>
		`;
	
		$('#productosMobile').append(contenido);

		if($("#tipoMoneda").val() == "2"){
			$('#divEfectivo').hide();
			$('#divVisa').hide();
			$('#divBac').hide();
			$('#divDolares').show();
		}
		getDatosVenta();
	}
}

function verificarCheque(){

	if(accounting.unformat($("#TxtCheques").val()) > 0){
		console.log("cheques");

		Swal.fire({

			html: `<div id="bloqueCheque">
					<b>Complete la siguiente informaci&oacute;n</b>
						<div style="padding-top: 20px;"><b>Banco:</b></div>
						<div style="padding-top: 15px;">
						<select class="browser-default" id="selectBancos" style="border-top-width: 10px;font-size: small;border: 1px solid white;border-bottom-color: #545454;width: 100% !important;"></select>
						</div>
						<div style="padding-top: 20px;"><b>No. Cheque:</b></div>
						<div>
							<input id="numeroCheque" placeholder="Numero de Cheque" style="width: 100% !important;margin-top: 10px;" required type="number"/>
						</div>
					</div>`,
			showConfirmButton: true,
			showCancelButton: true,
			confirmButtonColor: '#ff8f00',
			cancelButtonText: "Cancelar",
			confirmButtonText: "Confirmar",
			onOpen() {
				getBancos();
			},
			customClass: {
				container: 'my-swal'
			}	
		}).then((result) => {
			if (result.isConfirmed) {
				var errorMsg = "<b>Revise los siguientes campos: </b></br>";
				var flag = true;
				if ($("#numeroCheque").val() == "") {
					flag = false;
					errorMsg += "Ingrese el n&uacute;mero de cheque </br>";
				}
				if ($("#selectBancos").val() == "0") {
					flag = false;
					errorMsg += "Seleccione un banco</br>";
				}
				if (flag === false) {
					Swal.fire({
						html: errorMsg,
						icon: "warning",
						confirmButtonColor: "#3085d6",
						confirmButtonText: "Ok",
					}).then((result) => {});
					return false;
				}else{
					$("#numeroCheque1").val($("#numeroCheque").val());
					$("#selectBancos1").val($("#selectBancos").val());
					confirmCompra();
				}
			}		
		});
	}else{
		confirmCompra();
	}
}

function getBancos(){
	params = {
		service: "getBancos",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		let bancos = "<option value='0'>Seleccione un banco...</option>";
		//let bancos = "<option value=''>Seleccione un banco...</option>";
		$.each(data, function (key, val) {
			bancos += `<option value="${val.id}"> ${val.descripcion}</option>`;
		});
		$("#selectBancos").html(bancos);
	}, "json").done(function(){
		$("#loader").hide();
	});
	//get the id - save
	$("#selectBancos").on("change", function () {
		console.log($("#selectBancos").val());
	});
}

function showFacturacion(){
	$('#btnBackTool').attr('onclick', 'showCobro()');
	$('#btnBackTool2').hide();
	$('#btnBackTool').show();
	$('#divFormasPago').slideUp();

	drawFacturacion();

	$('#btnFinVenta').show();
}

function drawFacturacion(){
	let nombre = $("#nombreC").val();
	let direccion = $("#direccionC").val();

	let nitC;
	
	if ($("#nitC").val() === "N/A"){
		nitC = "";
	}else{
		nitC = $("#nitC").val();
	}
	let contenido = `
	<div id="facturaDatos" class="mdl-grid">
		<div class="mdl-cell mdl-cell--4-col-phone">
			<form id="divDatosFactura"> 
				<div class="mdl-textfield mdl-js-textfield " style="padding: 10px 0px;">
					<input placeholder="CF" class="mdl-textfield__input" type="text" id="nitC" value="${nitC}">
				</div>

				<div class="mdl-textfield mdl-js-textfield " style="padding: 10px 0px;">
					<input placeholder="Consumidor Final" class="mdl-textfield__input" type="text" id="nombreU" value="${nombre}">
				</div>

				<div class="mdl-textfield mdl-js-textfield " style="padding: 10px 0px;">
					<input placeholder="Direccion" class="mdl-textfield__input" type="text" id="direccionU" value="${direccion}">
				</div>
    		</form>
		</div>    
	</div>
	<div id="divNumPadNIT" class="mdl-grid" style="text-align:center; padding: 0px;"></div>`;
	$('#productosMobile').append(contenido);
	createNumPad("divNumPadNIT", "nitC", "K", "", "");
	//Mostrar switch de recibo o factura
	$('#divTipTrans').show();
}

// ?
//getProductos regresa los productos (sin categoria) y con precio en Q y precio $
function getProductos() {
    $("#txtScanner").focus();
	params = {
		service: "getProductos",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales
	};
	$.post(host, params, function (data) {
		$("#productosMobile").empty();
		var component = ``;
		$.each(data, function (key, val) {
			let color = accounting.unformat(val.existencia) > 0 ? "light-green" : "deep-orange ";
			let icon = accounting.unformat(val.existencia) > 0 ? "check" : "clear";
			//let showIcon = val.idTipoProductos == 3 ? false : true;
			productoVenta = `agregarProductoVenta(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',1, ${val.precioPublico},0,${$("#precioDolar").val()},1);`;

			//De momento no se usa en el mobile
			if (pVariable && val.precioPublico == 0) {
				// swalPrecioPublico();
				productoVenta = `swalPrecioPublico(${
					val.id
				},${accounting.unformat(val.existencia)},${
					val.idTipoProductos
				},'${val.descLarga}',1);`;
			} else {
				productoVenta = `agregarProductoVenta(${
					val.id
				},${accounting.unformat(val.existencia)},${
					val.idTipoProductos
				},'${val.descLarga}',1, ${val.precioPublico},0,${$("#precioDolar").val()},1);`;
           	}
			if (val.menuOpcion != "No tiene Opcion"){
                component += `
				<div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-phone">
				<div class="mdl-card mdl-shadow--2dp card shapedbox" onclick="opcionesProducto(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',${val.precioPublico},${val.precioDolar})" >
				<p class="nombre-card-Mobile">${val.descLarga.toLowerCase()}</p>
                    <div class="mdl-card__supporting-text">
                    <br> 
						<p class='truncate sku-card'>
							${val.sku}
						</p>`;
			} else {
                component += `
                <div class="mdl-cell mdl-cell--12-col mdl-cell--12-col-phone">
				<div class="mdl-card mdl-shadow--2dp card shapedbox"  onclick="modalAgregarProducto(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',${val.precioPublico},${val.precioDolar})" >
				<p class="nombre-card-Mobile">${val.descLarga.toLowerCase()}</p>
                    <div class="mdl-card__supporting-text">
                    <br> 
						<p class='truncate sku-card'>
							${val.sku}
						</p>`;
            }
                /*
				if (showIcon) {
					component += `<a class="btn-existencias btn-floating btn-flat btn-small waves-effect waves-light ${color}"><i class="material-icons">${icon}</i></a>`;
                }
                */
				//component += `<div style="float: right;">${val.menuOpcion}</div></br>`;
			component += `<p class='precio-card accent-color' style="font-size: large; margin-bottom: 0px !important;">`;

			if ($("#tipoMoneda").val() == "2"){ //Si es Dolar:
				component += `$${val.precioDolar}`;
			} else {
				component += `Q${val.precioPublico}`;			
			}
			component += `		</p>
							
							</div>
						</div>
					</div>`;
			});
			
			$("#productosMobile").append(component);
			$('#divTipMoneda').show();
		},
		"json",
	);
}

function returnProductos(){
	$('#btnBackTool').show();
	$('#textBuscador').show();
	$('#btnBackTool').attr('onclick', 'showDetalles()');

	$('#divTipMoneda').show();
	$('#productosMobile').height(canvasH);
	$('#productosMobile').empty();

	getProductos();
	
	$('#btnDetalles').hide();
	$('#btnTotal').hide();
	$('#btnDespachar').show();
}