$(document).ready(function() {
    var fechaSinFormato = new Date();
    var fechaActual = fechaSinFormato.getFullYear() + "-" + ("0"+(fechaSinFormato.getMonth()+1)).slice(-2) + "-" + ("0" + fechaSinFormato.getDate()).slice(-2);
    transacciones(fechaActual,fechaActual);
    drawBtn(fechaActual,fechaActual);
    datePickerRange();
    resizeDOMHeights();
    eliminarCarritoNotas();

    if (localStorage.isMobile == "false"){
         $('#modalFactura').modal({
        /*onOpenEnd() {
            window.focus();
            window.print();
        },*/
        }); 
    }
   
    console.log(shopFacturas);

}); 

//DatePicker version movil
function datepicker(fechaActual) {
    $("#datePicker").html("");
    var maxDay = "";
    maxDay = `<input class="mdl-textfield__input" type="date" max="${fechaActual}" value="${fechaActual}" id="date">`;
    maxDay += `<label class="mdl-textfield__label" for="date">Filtrar por fecha</label>`;
    $("#datePicker").html(maxDay);
}

function anulacionFactura(idVenta,fechaInicio,fechaFin) {
    const { value: motivo } =  Swal.fire({
        title: 'Motivo de la Anulaci&#243;n',
        input: 'text',
        showCancelButton: true,
        cancelButtonText: 'Cancelar',
        confirmButtonText: 'Ok',
        confirmButtonColor: '#ff8f00',
        inputPlaceholder: 'Ingresa el motivo de la anulacion',
        footer: '<span style="color:#ff0000">Este campo es obligatorio</span>',
        allowOutsideClick: false,
        inputValidator: (value) => {
            if (!value) {
                return "No puedes enviar el motivo en blanco";
            }
        }
    }).then((result) => {
        if (result.value) {
            var res = JSON.stringify(result.value)
            var motivo = res.replace(/[_\W]+/g, " ");
            //console.log(motivo)
            params = {
                service: 'anulacionFactura',
                dbName: dbName,
                urlFEL: urlFEL,
				tokenFEL: tokenFEL,
                idEmpresas: localStorage.idEmpresas,
                idSucursales: localStorage.idSucursales,
                idUsuarios: localStorage.idUsuarios,
                idVenta: idVenta,
                motivo: motivo
            };

            $("#loader").show();
            $.post(host, params, function(data) {
                console.log(data);
                switch(data.message){
                    case 'success':
                        Swal.fire({
                            icon: 'success',
                            html: 'Documento anulado con &#233;xito',
                            showConfirmButton: false,
                            timer: 1500
                        });
                        transacciones(fechaInicio,fechaFin);
                        break;
                    default:
                        Swal.fire({
                            icon: 'error',
                            title: `Error al anular documento`, 
                            html: data.error,
                            showCloseButton: true,
							confirmButtonText: "Intentar de nuevo",
                        });
                        //alert(data.error); 
                    break;
                }
            }, 'json').done(function() {
                $("#loader").hide();
            });
            
        }
    })
};

function transacciones(fechaInicio,fechaFin) {
    params = {
        service: 'transacciones',
        dbName: dbName,
        idEmpresas: localStorage.idEmpresas,
        idSucursales: localStorage.idSucursales,
        fechaInicio: fechaInicio,
        fechaFin: fechaFin
    };
    $('#dataTable').DataTable().clear().destroy()
    $.post(host, params, function(data) {
        var totalQ = 0;
        var totalNCRE = 0;
        var totalDolares = 0;
        var descuentos = 0;
        $.each(data, function(key, val){
            if (val.anulacion == "0"){
            //total += accounting.unformat(val.valorFactura);
                if (val.tipoTransaccion != "2"){
                    totalQ += accounting.unformat(val.total);
                    totalDolares += accounting.unformat(val.totalDolares);
                    descuentos += accounting.unformat(val.descuento);
                }else{
                    totalNCRE += accounting.unformat(val.total);
                }
            }
        });

        $('#dataTable').DataTable().clear().destroy()
        $('#dataTable').DataTable({
            responsive: true,
            //fixedColumns: true,
            fixedHeader: true,
            lengthChange: false,
            bDestroy: true,
            pageLength: 8,
            columnDefs: [
                { 
                    targets: [0, 1],
                    className: "text-center", 
                    width: 20
                }
            ],
            oLanguage: { "sSearch": "" }, 
            language: {
                lengthMenu: "Mostrar _MENU_ registros por pagina",
                zeroRecords: "No se encontraron resultados en su busqueda",
                searchPlaceholder: "Buscar registros",
                info: "Mostrando registros de _START_ al _END_ de un total de  _TOTAL_ registros.",
                infoEmpty: "No existen registros",
                infoFiltered: "(filtrado de un total de _MAX_ registros)",
                //search: "Buscar:",
                paginate: {
                    first: "Primero",
                    last: "Último",
                    next: "Siguiente",
                    previous: "Anterior"
                },
            },
            data: JSON.parse(JSON.stringify(data)),
            columns: [
                //0
            { 
                "title": '<i class="Small material-icons">receipt</i>',
                "data": "Estado",
                "render": function (data, type, row) {
                    return `<center><i class="Small material-icons" style="color:#00897b;cursor:pointer" onclick="printer(${row['id']},${row['tipoTransaccion']}, false, 0)">receipt</i></center>`;
                },
            },
            //1
            { 
                "title": '<i class="Small material-icons">card_giftcard</i>',
                "data": "Estado",
                "render": function (data, type, row) {
                    return `<center><i class="Small material-icons" style="color:#00897b;cursor:pointer" onclick="printerCambio(${row['id']}, 0)">card_giftcard</i></center>`;
                },
            },
            //2
            { 
                "title": '<i class="Small material-icons">file_download</i>',
                "data": "Estado",
                "render": function (data, type, row) {
                    return `<center><i class="Small material-icons" style="color:#00897b;cursor:pointer" onclick="downloadFactura(${row['id']})">file_download</i></center>`;
                },
            },
            //3
            { 
                "title": '<i class="Small material-icons">cancel</i>',
                "data": "Estado",
                "render": function (data, type, row) {
                    let btnAnulacion;
                    let fechaSinFormato = new Date();
                    let fechaActual = fechaSinFormato.getFullYear() + "-" + ("0"+(fechaSinFormato.getMonth()+1)).slice(-2) + "-" + ("0" + fechaSinFormato.getDate()).slice(-2);

                    let startDate = moment(row['fechaFactura'], 'YYYY-MM-DD');
                    let endDate = moment(fechaActual, 'YYYY-MM-DD');
            
                    let dayDiff = endDate.diff(startDate, 'days');
                    let monthDiff = endDate.diff(startDate, 'months');

                    if(row['Estado'] == 'ACTIVA'){
                        if(dayDiff < 5){
                            btnAnulacion = `<center><i class="Small material-icons" id="anulacion" style="color:#d84315;cursor:pointer" onclick="anulacionFactura(${row['id']},'${fechaInicio}','${fechaFin}')">cancel</i></center>`;
                        }else{
                            btnAnulacion = `<center><i class="Small material-icons" style="color:#d84315;">highlight_off</i></center>`;
                        }
                    }
                    else{
                        btnAnulacion = `<center><i class="Small material-icons" style="color:#d84315;">highlight_off</i></center>`;
                    }

                    return btnAnulacion; 
                },
            },
            //4
            { 
                "title": '<i class="Small material-icons">chrome_reader_mode</i>',
                "data": "Estado",
                "render": function (data, type, row) {
                    let btnNota;
                    let fechaSinFormato = new Date();
                    let fechaActual = fechaSinFormato.getFullYear() + "-" + ("0"+(fechaSinFormato.getMonth()+1)).slice(-2) + "-" + ("0" + fechaSinFormato.getDate()).slice(-2);

                    let startDate = moment(row['fechaFactura'], 'YYYY-MM-DD');
                    let endDate = moment(fechaActual, 'YYYY-MM-DD');
            
                    let dayDiff = endDate.diff(startDate, 'days');
                    let monthDiff = endDate.diff(startDate, 'months');
                
                    //console.log(monthDiff," ",dayDiff);
                    //! AGREGAR LA CONDICIONAL EN EL IF PARA LOS DIAS
                    if(row['tipoTransaccion'] == '2' || row['idVentasOrigen'] == '0' || row['tipoTransaccion'] == '0'){
                        btnNota = `<center><i class="Small material-icons" style="color:#757575;cursor: pointer;">chrome_reader_mode</i></center>`;
                    }else{
                        if(monthDiff < 2){
                            btnNota = `<center><i class="Small material-icons" id="notaCredito" style="color:#00897b;cursor: pointer;" onclick="viewNotasCredito(${row['id']},'${row['fechaFactura']}')">chrome_reader_mode</i></center>`;
                        }else{
                           btnNota = `<center><i class="Small material-icons" style="color:#757575;cursor: pointer;">chrome_reader_mode</i></center>`;
                        }
                    }
                    return btnNota; 
                },
            },
            { data: "tipoTransaccionTXT" },
            { data: "Estado" },
            { data: "serie" },
            { data: "correlativo" },
            { data: "fechaConFormato" },
            { data: "nit" },
            { data: "nombre" },
            { 
                "title": "Descuento",
                "data": "descuento",
                "render": function (data, type, row) {
                return accounting.formatNumber(row['descuento'],2);
                },
            },
            { 
                "title": "Total",
                "data": "total",
                "render": function (data, type, row) {

                    if (row['total'] == 0){
                        return "$" + accounting.formatNumber(row['totalDolares'],2);
                    }else{
                        return "Q" + accounting.formatNumber(row['total'],2);
                    }

                },
            },
            ]
        });

        if (localStorage.tipoUsuario == 1 || localStorage.tipoUsuario == 2) {
            $('#dataTable').DataTable().column(3).visible(true);
        }else{
            $('#dataTable').DataTable().column(3).visible(false);
        }

        if (devoluciones) {
            $('#dataTable').DataTable().column(1).visible(true);
        }else{
            $('#dataTable').DataTable().column(1).visible(false);
        }

        if (notaCredito) {
            $('#dataTable').DataTable().column(4).visible(true);
        }else{
            $('#dataTable').DataTable().column(4).visible(false);
        }

        var summary = `<div>Total Ventas Q: ${accounting.formatNumber(totalQ,2)}</div>`;
        summary += `<div style="font-size:20px; padding-top: 5px;">Total Notas de Cr&eacute;dito: ${accounting.formatNumber(totalNCRE,2)} </div>
        <div style="font-size:20px; padding-top: 5px;"> Total Descuentos: ${accounting.formatNumber(descuentos,2)} </div>`;
        $("#ventas").html(summary);
    }, 'json').done(function(){
    });
}

//* Dibuja el boton para mandar fechas a la funcion
function drawBtn(fechaInicio,fechaFin){
    $("#drawBtn").html("");
    let component = "";

    //Selecciona el estilo de boton de exportar reporte segun version utilizada
    if (localStorage.isMobile == "true"){
        component += `<form>
            <button type='button' id="export" class="mdl-cell mdl-cell--12-col mdl-cell--6-col-phone mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect shapedbox" 
            style="background-color: #ff8f00;height:45px;" onclick="getDatosReporte('${fechaInicio}','${fechaFin}')">Exportar Reporte</button>
        </form>`
    }else{
        component += `<form>
            <div id="export" class="btn-large waves-effect waves-light" style="background-color: #ff8f00;" onclick="getDatosReporte('${fechaInicio}','${fechaFin}')">Exportar Reporte</div>
        </form>`;
    }
    
    $("#drawBtn").html(component);
}

//* Funcion que obtiene los datos de la consulta
function getDatosReporte(fechaInicio,fechaFin){
    params = {
        service: 'getDatosReporte',
        dbName: dbName,
        fechaInicio: fechaInicio,
        fechaFin: fechaFin
    };
    $.post(host, params, function(data) {
        exportarReporte(data);
    }, 'json');
}

//* Funcion para mandar el archivo por correo
function exportarReporte(datos){
console.log(datos);
    params = {
        service: 'reporteTransac',
        dbName: dbName,
        datos: datos,
        idEmpresas: localStorage.idEmpresas
    };
    $.post(host, params, function(data) {
    }, 'json').done(function(){});
    
    Swal.fire({
        icon: 'success',
        html: 'Reporte Enviado con &#233;xito',
        showConfirmButton: false,
        timer: 1500
    });
}

//* Redireccion a la pantalla de notas de crédito de esa venta seleccionada
function viewNotasCredito(id,fecha){
    //sessionStorage.idAjuste = undefined;
    sessionStorage.idNota = id;
    window.location = "notasCredito.html";
}

function datePickerRange(){
    $('input[name="daterange"]').daterangepicker({
        startdate: new Date(), //Fecha inicial default
        endDate: new Date(), //Fecha final default
        maxDate: new Date(),
      }, function(start, end, label) {
        //console.log("A new date selection was made: " + start.format('YYYY-MM-DD') + ' to ' + end.format('YYYY-MM-DD'));
        //console.log(start.format('YYYY-MM-DD'))
        let inicio = start.format('YYYY-MM-DD');
        let fin = end.format('YYYY-MM-DD');
        drawBtn(inicio,fin);
        transacciones(inicio,fin);
      });
}

function downloadFactura(id){
    $("#headers1").empty();
	$("#facturaFoot1").empty();
	params = {
		service: "generarFormatoFEL",
		idVenta: id,
		dbName: dbName
	};
	$.post(host, params, function (data) {
		let headers = ``;
		$.each(data, function (key, val) {
            let datFact = val.data;
	        let detVenta = val.detalle;

            var i = 0;
            while (detVenta[i]) {
                let item = detVenta[i];
                i++;
            }

			headers += `
                <div>
                    <div>
                        <div>
                            <div>
                                <h4 style='text-align: center'>${datFact.Empresa}</h4>
                                <h5 style='text-align: center'>${datFact.razonSocial}<br>
                                ${datFact.direccion}<br>
                                ${datFact.NIT}</h5>
                            </div>
                            <div>
                                <h6 style='text-align: center'>${datFact.tipoAfiliacion}<br><br> 
                                    DOCUMENTO ELECTRONICO <br>
                                    ${datFact.leyendaFEL}<br>
                                    Numero Autorizacion: <br>
                                    ${datFact.AutorizacionFEL}<br>
                                    Fecha Certificacion:
                                    ${datFact.FechaEmisionFEL}<br>
                                    DIGIFACT, S.A. | NIT: 77454820
                                </h6>
                            </div>
                            
                            <div>
                                <h6 style='margin-left: 18%;'>Serie: ${datFact.serie}<br>
                                    Numero: ${datFact.correlativo}<br>
                                    Fecha Emision: ${datFact.FechaFactura}<br>
                                    NIT: ${datFact.nitCliente}<br>
                                    Nombre: ${datFact.nombreCliente}<br>
                                    Direccion: ${datFact.direccionCliente}<br>
                                </h6>
                            </div>
                        </div>
                    </div>
                    <div>
                        <div>
                            <div>
                                <h5 style='text-align: center'>- DETALLE POR PRODUCTO -</h5>
                            </div>
                            <div>                                
                                <table style='font-size: 12px;margin-left: auto; margin-right: auto;'>
                                    <tr>
                                        <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                            <b>CANT.</b> 
                                        </th>
                                        <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: left; width: 50%;'>
                                            <b>DESCRIPCION.</b> 
                                        </th>                                            
                                        <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                            <b>PRECIO.</b> 
                                        </th>
                                        <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                            <b>TOTAL.</b> 
                                        </th>
                                    </tr>`;

                                    var i = 0;
                                    while (detVenta[i]) {
                                        let item = detVenta[i];

                                        headers += `
                                        <tr>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                                ${item.Cantidad} <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 10px; text-align: left;'>
                                                ${item.DescCorta} <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 10px; text-align: right;'>
                                                Q${item.PrecioUnitario} <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                                Q${item.Total} <br>
                                            </td>
                                        </tr>`;
                                        i++;
                                    }

                            headers += ` 
                                </table>
                            </div>
                            <div style='text-align: center;'>
                                <h5>- TOTAL: Q${datFact.total} -</h5>
                                Powered by Proper <br>
                                www.somosproper.com
                            </div>
                        </div>
                    </div>
                </div>`;
		});
        //console.log(headers);
		$("#headers1").html(headers);
        
	}, "json").done(function(){
        //$("#modalFactura").modal("open");
        window.print();
	});
}

function reprintHeaderFactura(id){
    console.log("here");
	$("#headers1").empty();
	$("#facturaFoot1").empty();
	params = {
		service: "reprintFactHeader",
		dbName: dbName,
        id: id
	};
	$.post(host, params, function (data) {
		let headers = ``;
        let divTable = ``;
        let headerTable = ``;
		let foot1 = ``;
		let foot = ``;
		$.each(data, function (key, val) {
            var logo;
			//Seleccion de datos empresa
			switch (val.idEmpresas) {
				case "1":
					logo = "unicable.jpg";
					break;
				case "2":
					logo = "proyectosCipresales.jpg";
					break;
				case "3":
					logo = "cableSanAntonio.jpg";
					break;
				default:
					break;
			}

			if(val.autorizacionFEL === null){
				var autorizacion = "N/A";
			}else{
				var autorizacion = val.autorizacionFEL;
			}
			if(val.fechaEmisionFEL === null){
				var fechaHora = "N/A";
			}else{
				var fechaHora = val.fechaEmisionFEL;
			}
			headers += `
			<div style="display: grid;grid-template-columns: auto auto auto auto;">
				<div style="grid-column: 1 / span 3;text-align: center;">
					<img src="assets/images/${logo}" style="height: 60px;" /></br>
					<div style="display: inline-block;font-size: smaller;text-align: center;">
					<b style="font-size: x-large;">UNICABLE</b></br>
					CABLE, INTERNET Y DATOS</br>

					</div>
				</div>

				<div style="grid-column: 4/ span 2">
					<div style="background-color: #ee9b1b;color: white;border: 1px solid;border-bottom: unset;border-top-left-radius:15px;border-top-right-radius:15px;
					padding-left: 15px !important;padding: unset;text-align:center;">
						<b>DATOS DE LA FACTURA</b>
					</div>
					<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding-left: 15px !important;padding: unset;margin-bottom: 5px;">
						<b>No. AUTORIZACI&Oacute;N: </b> ${autorizacion} </br>
						<b>SERIE DE DOCUMENTO: </b> ${val.serie} </br>
						<b>No. DTE: </b> ${val.correlativo} </br>
						<b>FECHA DE EMISI&Oacute;N: </b> ${fechaHora} </br>
						<b>SALDO: </b> 
					</div>
				</div>

				<div class="sectionHeader" style="grid-column:1 / span 5;">
					<b>DATOS DEL CLIENTE</b>
				</div>
				<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding-left: 15px !important;padding: 10px; grid-column:1 / span 5">
					<b>NOMBRE DEL CLIENTE: </b>${val.nombre}<br>
					<b>NIT: </b>${val.nit}<br>
					<b>DIRECCI&Oacute;N: </b>${val.direccion}<br>
					<b>C&Oacute;DIGO DE CLIENTE: </b>${val.codigoC}<br>
				</div>	
			</div>`;
            divTable += `<div style="background-color: #346b88;color: white;border: 1px solid;border-bottom: unset;border-top-left-radius:15px;border-top-right-radius:15px;
            padding-left: 15px !important;padding: unset;text-align:center">
                <b>TOTAL POR SERVICIOS</b>
            </div>`;
            headerTable += `
            <tr>
                <th style="padding-left: 15px;">CANTIDAD</th>
                <th style="padding-left: 15px;">D E S C R I P C I &Oacute; N</th>
                <th style="padding-left: 15px;">P. UNITARIO</th>
                <th style="border-top-right-radius: 20px;padding-left: 15px;">IMPORTE</th>
            </tr>
            `;
            foot += `<div style="margin-top: 10px;margin-right: 10px;font-size: smaller;"><b>CERTIFICADOR: Digifact, S.A. NIT: 77454820 </b></br><b>DOCUMENTO ELECTRONICO, SUJETO A PAGOS TRIMESTRALES</b></br></div>
			`;
			foot1 += `
			<div class="sectionHeader" style="grid-column: 4 / span 2;">
					<b>TOTAL DE FACTURA</b>
			</div>
			<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding: 05px; grid-column: 4 / span 2;text-align:center;margin-bottom:05px;">
				<b>Q${accounting.formatNumber(val.total,2)}</b>
			</div>

			<div class="sectionHeader" style="grid-column:1 / span 5;">
					<b>TOTAL EN LETRAS</b>
			</div>
			<div style="margin-bottom:10px;border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding: 05px; padding-left: 15px !important;grid-column:1 / span 5">
				<b>${val.totalEnLetras}</b>
			</div>
			
			<div class="sectionHeader" style="grid-column: 4 / span 2;">
					<b>FORMA DE PAGO</b>
			</div>
			<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding: 05px; grid-column: 4 / span 2;text-align:center;margin-bottom:05px;">
				<b>${val.formaPago}</b>
			</div>
			`;
		});
        //console.log(headers);
		$("#headers1").html(headers);
        $("#bodyTable1 thead").html(headerTable);
        $("#divTabla").html(divTable);
		$("#facturaFoot").html(foot);
		$("#facturaFoot1").html(foot1);
	}, "json").done(function(){
		reprintDetallesFactura(id);
	});
}

function reprintDetallesFactura(id){
	$("#bodyTable1 tbody").empty();
	params = {
		service: "reprintFactDetail",
		dbName: dbName,
        id: id
	};
	$.post(host, params, function (data) {
		let table = ``;
		var total = 0;
		
		$.each(data, function (key, val) {
			total += accounting.unformat(val.total);
			table += `
				<tr>
					<td style="padding-left: 15px">${val.cantidad}</td>
					<td style="padding-left: 15px">${val.descLarga}</td>
					<td style="padding-left: 15px">${val.precio}</td>
					<td style="padding-left: 15px">${val.total}</td>
				</tr>
			`;
		});
		$("#bodyTable1 tbody").html(table);		
	}, "json").done(function(){    
        //$("#modalFactura").modal("open");
        window.print();
	});
}

function cerrarModalF() {
	$("#modalFactura").modal("close");
}


